require 'htauth'

class SvnauthController < ApplicationController
  unloadable

  def htpasswd
   if request.post?
    if !Setting.plugin_redmine_svnauth['svn_passwd_file'].nil? && !Setting.plugin_redmine_svnauth['svn_passwd_file'].empty?
      if check_password?(params[:password])
        if check_new_password?(params[:new_password], params[:new_password_confirmation])
          save_password(params[:new_password])                           
        end
      else
        flash[:error] = l(:notice_account_wrong_password)
      end
     else
       flash[:error] = l(:notice_error_svn_password_file_empty)
     end
    end
  end

  def check_password?(passwd)
     begin
	HTAuth::PasswdFile.open(Setting.plugin_redmine_svnauth['svn_passwd_file']) do |file|
	   entry = file.fetch(User.current.login)
	   valid = (!entry.nil?) ? entry.authenticated?(passwd) : false           
           logger.info("While changing svn password user '#{User.current.login}' enter invalid current svn password.")  if !valid 
           return valid        
	end
      rescue => e
        logger.error("Error when checking svn password for user '#{User.current.login}': #{e}")
      end
      return false
  end

  def check_new_password?(passwd, passwd_confirm)
    if passwd.length < Setting.password_min_length.to_i
        flash[:error] = l(:notice_svn_password_too_short, :value => Setting.password_min_length)
        return false
    end
    if passwd != passwd_confirm
       flash[:error] = l(:notice_svn_password_not_equal)
       return false
    end    
    return true
  end

  def save_password(passwd)
    begin
       HTAuth::PasswdFile.open(Setting.plugin_redmine_svnauth['svn_passwd_file']) do |file|
      	   file.add_or_update(User.current.login, passwd, 'md5')
       end
       flash[:notice] = l(:notice_svn_password_updated) 
       logger.info("User '#{User.current.login}' has been changed svn password successfully.")           
    rescue => e
       flash[:error] = l(:notice_error_svn_password_update)
       logger.error("Error when updating svn password for user '#{User.current.login}': #{e}")
    end
  end
end
